/*
 * SupplierViewer.java
 *
 * Created on 10 de agosto de 2004, 17:55
 */

package com.fenalco.servlets.shopkeeper;

import java.io.IOException;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import com.fenalco.entities.Company;
import com.fenalco.entities.Supplier;
import com.fenalco.entities.User;
import com.fenalco.utilities.MessageBuilder;

/**
 * Este servelet carga la información de un proveedor específico mediante una
 * instancia de la clase <CODE>Supplier</CODE> que es presentada a través de
 * la página verproveedor.jsp
 * 
 * @author Mario Linares Vásquez
 */
public class SupplierViewer extends HttpServlet
{

	/**
	 * Inicializa el servlet.
	 * 
	 * @param config
	 * @throws ServletException
	 */
	public void init( ServletConfig config ) throws ServletException
	{
		super.init(config);

	}

	/**
	 * Destructor de el servlet.
	 */
	public void destroy( )
	{

	}

	/**
	 * Procesa las solicitudes de los métodos HTTP <code>GET</code> y
	 * <code>POST</code>. Este método crea instancias de las clases <CODE>
	 * Supplier</CODE> y <CODE>Company</CODE> con el parámetro <CODE>id
	 * </CODE> del <CODE>request</CODE>, luego envía estas instancias a la
	 * página verproveedor.jsp a través del <CODE>response</CODE> como
	 * atributos con el nombre <CODE>supplier</CODE> y <CODE>company</CODE>
	 * respectivamente.
	 * 
	 * @param request
	 *            servlet request
	 * @param response
	 *            servlet response
	 * @throws ServletException
	 * @throws IOException
	 */
	protected void processRequest( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{

		String url = "/minorista/verproveedor.jsp";
        String message = "";
        HttpSession session = request.getSession( false );
	    try
	    {
	        if( session == null || ( User )session.getAttribute( "user" ) == null || ( ( User )session.getAttribute( "user" ) ).getRoleId() != 3 )
			{
	        	
			}
	        else
	        {
				int supplierId = Integer.parseInt(request.getParameter("id"));
				Supplier supplier = new Supplier(supplierId);
				Company company = new Company(supplierId);
		
				request.setAttribute("supplier", supplier);
				request.setAttribute("company", company);
	        }
	    }
	    catch( Exception e )
	    {
	        url="/logout";
	        message = MessageBuilder.buildMessage(15);
	    }

		RequestDispatcher dispatcher = getServletContext()
				.getRequestDispatcher(url);
		dispatcher.forward(request, response);

	}

	/**
	 * Procesa el método HTTP <code>GET</code>.
	 * 
	 * @param request
	 *            servlet request
	 * @param response
	 *            servlet response
	 * @throws ServletException
	 * @throws IOException
	 */
	protected void doGet( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Procesa el método HTTP <code>POST</code>.
	 * 
	 * @param request
	 *            servlet request
	 * @param response
	 *            servlet response
	 * @throws ServletException
	 * @throws IOException
	 */
	protected void doPost( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Retorna una breve descripción de el servlet.
	 * 
	 * @return
	 */
	public String getServletInfo( )
	{
		return "Short description";
	}

}